<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="" prop="userId">
        <el-input v-model="queryParams.userId" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="" prop="projectId">
        <el-input v-model="queryParams.projectId" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="" prop="taskId">
        <el-input v-model="queryParams.taskId" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="" prop="hour">
        <el-input v-model="queryParams.hour" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['farm:work-hour:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['farm:work-hour:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="员工名" align="center" prop="userId" >
        <template slot-scope="scope">
          <span>{{cpUserList.find(t=>t.id == scope.row.userId).name}}</span>
        </template>
      </el-table-column>
      <el-table-column label="项目名" align="center" prop="projectId" >
        <template slot-scope="scope">
          <span>{{projectList.find(t=>t.id == scope.row.projectId).name}}</span>
        </template>
      </el-table-column>
      <el-table-column label="任务名" align="center" prop="taskId" >
        <template slot-scope="scope">
          <span>{{taskList.find(t=>t.id == scope.row.taskId).name}}</span>
        </template>
      </el-table-column>
      <el-table-column label="工时" align="center" prop="hour" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['farm:work-hour:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['farm:work-hour:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="项目" prop="projectId">
          <el-select  v-model="form.projectId" @change="chooseProject"  placeholder="请选择">
            <el-option
              v-for="item in projectList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="任务" prop="taskId">
          <el-select  v-model="form.taskId"  @change="chooseTask" placeholder="请选择">
            <el-option
              v-for="item in selectTaskList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
              @change="chooseTask">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="员工" prop="userId">
          <el-select  v-model="form.userId"  placeholder="请选择">
            <el-option
              v-for="item in selectCpUserList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="工时" prop="hour">
          <el-input v-model="form.hour" placeholder="请输入" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createWorkHour, updateWorkHour, deleteWorkHour, getWorkHour, getWorkHourPage, exportWorkHourExcel } from "@/api/farm/workHour";
import { getProjectPage} from "@/api/farm/project";
import { getTaskPage} from "@/api/farm/task";
import { getCpUserPage} from "@/api/system/cpUser"


export default {
  name: "WorkHour",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        userId: null,
        projectId: null,
        taskId: null,
        hour: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        hour: [{ required: true, message: "不能为空", trigger: "blur" }],
      },

      projectList: [],
      taskList:[],
      selectTaskList:[],
      cpUserList:[],
      selectCpUserList:[]


    };
  },
  created() {
    this.getProjectPageList();
    this.getTaskPageList();
    this.getCpUserPageList();
    this.getList();
  },
  methods: {
    getProjectPageList(){
      getProjectPage({
        pageNo:1,
        pageSize:100
      }).then(res => {
        this.projectList = res.data.list;
      })
    },
    getTaskPageList(){
      getTaskPage({
        pageNo:1,
        pageSize:100
      }).then(res => {
        this.taskList = res.data.list;
      })
    },
    getCpUserPageList(){
      getCpUserPage({
        pageNo:1,
        pageSize:100
      }).then(res => {
        this.cpUserList = res.data.list;
      })
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getWorkHourPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        userId: undefined,
        projectId: undefined,
        taskId: undefined,
        hour: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTaskPageList();
      this.getCpUserPageList();

      const id = row.id;
      getWorkHour(id).then(response => {
        let task = this.taskList.filter(t => t.id == response.data.taskId);
        this.form = response.data;
        this.taskId = task[0].name;
        let taskArr = this.taskList.filter(t => t.projectId == response.data.projectId);
        this.selectTaskList = taskArr;
        let userName = this.cpUserList.filter(t => t.id == response.data.userId);
        this.form.userId = userName[0].name;
        this.selectCpUserList = [];
        let userIdArr = [];
            userIdArr =  JSON.parse(task[0].executorPerson);
            userIdArr.push(task[0].mainPerson);
        let userArr = [];
          userIdArr.forEach(item =>{
            this.cpUserList.forEach(u =>{
              if(u.id == item){
                userArr.push(u);
              }
            })
          })
          let mapp = new Set(userArr);
          let quchong = Array.from(mapp);
          this.selectCpUserList = quchong;
    
        this.open = true;
        this.title = "修改";

      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateWorkHour(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createWorkHour(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除编号为"' + id + '"的数据项?').then(function() {
          return deleteWorkHour(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有数据项?').then(() => {
          this.exportLoading = true;
          return exportWorkHourExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    },

    chooseProject(row){
      this.form.taskId = undefined;
      this.form.userId = undefined;
      this.selectTaskList = [];
      this.selectCpUserList = [];
      this.taskList.forEach(item=>{
      if(row == item.projectId){
        this.selectTaskList.push(item);
      }
     })

    },

    chooseTask(row){
     this.form.userId = undefined;
     this.selectCpUserList = [];
     let arr = this.selectTaskList.filter(t => t.id == row)
     let userIdArr = [];
     arr.forEach(item =>{
        userIdArr =  JSON.parse(item.executorPerson);
        userIdArr.push(item.mainPerson);
     })
     let userArr = [];
      userIdArr.forEach(item =>{
        this.cpUserList.forEach(u =>{
          if(u.id == item){
            userArr.push(u);
          }
        })
      })
      let mapp = new Set(userArr);
      let quchong = Array.from(mapp);
      this.selectCpUserList = quchong;
    }
  }
};
</script>
